"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

var _utils = require("./utils");

var _beforeCollect = _interopRequireDefault(require("./before-collect"));

var _beforeProps = _interopRequireDefault(require("./before-props"));

var _beforeAction = _interopRequireDefault(require("./before-action"));

var _component = _interopRequireDefault(require("./component"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function replaceVueLikeProto(target) {
  var REACT_LIFECYCLE_HOOKS = ['render', 'renderError', 'componentDidMount', 'getSnapshotBeforeUpdate', 'componentDidUpdate', 'componentDidActivate', 'componentWillUnactivate', 'componentWillUnmount', 'componentDidCatch'];
  var ret = {};
  var isVueLike = (0, _utils.isVueLikeComponent)(target);
  var tp = target.prototype;
  var tm = Object.getOwnPropertyNames(tp);
  REACT_LIFECYCLE_HOOKS.forEach(function (key) {
    var sfn = _component.default.prototype[key];
    if (!tm.includes(key)) return;
    var tfn = tp[key];

    if (tfn) {
      tp[key] = sfn;
      ret[key] = tfn;
    } else if (!isVueLike) (0, _utils.innumerable)(tp, key, sfn);
  });
  return ret;
}

function walkMixins(mixins, target) {
  mixins.forEach(function (mixin) {
    // eslint-disable-next-line
    if (mixin.props) target = (0, _beforeProps.default)(mixin, target);
    (0, _beforeAction.default)(mixin);
  });
}

function beforeConstructor(target, props, children) {
  if (target.vuelikeProto) return;
  var vuelikeProto = replaceVueLikeProto(target);
  (0, _utils.innumerable)(target, 'vuelikeProto', vuelikeProto);

  if ((0, _utils.hasOwnProperty)(target.prototype, 'shouldComponentUpdate')) {
    vuelikeProto.shouldComponentUpdate = target.prototype.shouldComponentUpdate;
    delete target.prototype.shouldComponentUpdate;
  }

  (0, _beforeCollect.default)(vuelikeProto, _component.default);
  Object.keys(props).forEach(function (key) {
    return /^\$/.test(key) && (0, _utils.innumerable)(props, key, props[key]);
  });

  if (props.ref) {
    (0, _utils.innumerable)(props, '$ref', props.ref);
    delete props.ref;
  }

  var mixins = [target];
  if (target.mixins) Array.prototype.push.apply(mixins, target.mixins);
  walkMixins(mixins, target);
}

var _default = beforeConstructor;
exports.default = _default;